//+------------------------------------------------------------------+
//|                                                           CC.mq4 |
//|                                              SemSemFX@rambler.ru |
//|              http://onix-trade.net/forum/index.php?showtopic=107 |
//|              modified by finimej: http://www.formulatrader.com   |
//|              2014 modified by bartmichael                        |
//+------------------------------------------------------------------+
#property copyright "SemSemFX@rambler.ru"
#property link      "http://onix-trade.net/forum/index.php?showtopic=107"
//----
string Indicator_Name = "CC:    ";
int Objs = 0;
//----
#property indicator_separate_window
#property indicator_buffers 8


//---- parameters
extern bool CalcMorePairs = true; //use more pairs for calculation
extern bool ShowOnlyPairOnChart = true;
extern int MA_Method = MODE_LWMA;//MODE_EMA;//1 original 3 = MODE_LWMA;
extern int Applied_Price = PRICE_WEIGHTED;//PRICE_CLOSE; //0 original 6 = PRICE_WEIGHTED;
extern bool NormalizeValue = true;
extern bool USD = 1;
extern bool EUR = 1;
extern bool GBP = 1;
extern bool CHF = 1;
extern bool JPY = 1;
extern bool AUD = 1;
extern bool CAD = 1;
extern bool NZD = 1;
extern bool UseNihilistColors = true;
extern color Color_USD = DarkTurquoise;
extern color Color_EUR = Lime;
extern color Color_GBP = Orange;
extern color Color_CHF = White;
extern color Color_JPY = Magenta;
extern color Color_AUD = Red;
extern color Color_CAD = Yellow;
extern color Color_NZD = Blue;
extern int Line_Thickness = 2;
extern bool SaveFile = false; //for debugging purposes
extern int All_Bars = 0;
extern int Last_Bars = 0;
// for monthly
extern int mn_per = 12;
extern int mn_fast = 3;
// for weekly
extern int w_per = 9;
extern int w_fast = 3;
// for daily
extern int d_per = 5;
extern int d_fast = 3;
// for H4
extern int h4_per = 18;
extern int h4_fast = 6;
// for H1
extern int h1_per = 24;
extern int h1_fast = 8;
// for M30
extern int m30_per = 16;
extern int m30_fast = 2;
// for M15
extern int m15_per = 16;
extern int m15_fast = 4;
// for M5
extern int m5_per = 12;
extern int m5_fast = 3;
// for M1
extern int m1_per = 30;
extern int m1_fast = 10;
//----
int LineWidth = 2;
bool JPY100 = true;

double arrUSD[];
double arrEUR[];
double arrGBP[];
double arrCHF[];
double arrJPY[];
double arrAUD[];
double arrCAD[];
double arrNZD[];
  int Slow, Fast;
  string endfx;
  bool noendfx=true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   endfx = StringSubstr(Symbol(),6,StringLen(Symbol())-6);
   if (NormalizeValue){
     IndicatorSetDouble(INDICATOR_MINIMUM,0);
     IndicatorSetDouble(INDICATOR_MAXIMUM,100);
   }
   else
   { /* IndicatorSetDouble(INDICATOR_MINIMUM,-0.05);
     IndicatorSetDouble(INDICATOR_MAXIMUM,0.05); /**/
   }

   switch(Period())
     {
       case 1:     Slow = m1_per; Fast = m1_fast;  break;
       case 5:     Slow = m5_per; Fast = m5_fast;  break;
       case 15:    Slow = m15_per;Fast = m15_fast; break;
       case 30:    Slow = m30_per;Fast = m30_fast; break;
       case 60:    Slow = h1_per; Fast = h1_fast;  break;
       case 240:   Slow = h4_per; Fast = h4_fast;  break;
       case 1440:  Slow = d_per;  Fast = d_fast;   break;
       case 10080: Slow = w_per;  Fast = w_fast;   break;
       case 43200: Slow = mn_per; Fast = mn_fast;  break;
     }
//---- indicators
 if(USD)
       Indicator_Name = StringConcatenate(Indicator_Name, " USD");
   if(EUR)
       Indicator_Name = StringConcatenate(Indicator_Name, " EUR");
   if(GBP)
       Indicator_Name = StringConcatenate(Indicator_Name, " GBP");
   if(CHF)
       Indicator_Name = StringConcatenate(Indicator_Name, " CHF");
   if(AUD)
       Indicator_Name = StringConcatenate(Indicator_Name, " AUD");
   if(CAD)
       Indicator_Name = StringConcatenate(Indicator_Name, " CAD");
   if(JPY)
       Indicator_Name = StringConcatenate(Indicator_Name, " JPY");
   if(NZD)
       Indicator_Name = StringConcatenate(Indicator_Name, " NZD");
   IndicatorShortName(Indicator_Name);
   int cur = 0; 
   int st = 23;
   int ColorUSD, ColorEUR, ColorGBP, ColorCHF, ColorJPY, ColorAUD, ColorCAD, ColorNZD;
   if (UseNihilistColors){
     ColorUSD = White;
     ColorEUR = Aqua;
     ColorGBP = Red;
     ColorCHF = Chocolate;
     ColorJPY = Yellow;
     ColorAUD = Lime;
     ColorCAD = HotPink;
     ColorNZD = DodgerBlue;
   }
   else
   {
     ColorUSD = Color_USD;
     ColorEUR = Color_EUR;
     ColorGBP = Color_GBP;
     ColorCHF = Color_CHF;
     ColorJPY = Color_JPY;
     ColorAUD = Color_AUD;
     ColorCAD = Color_CAD;
     ColorNZD = Color_NZD;
   }
   if(USD)
     {
       sl("~", cur, ColorUSD);
       cur += st;
     }
   if(EUR)
     {
       sl("~", cur, ColorEUR); 
       cur += st;
     }
   if(GBP)
     {
       sl("~", cur, ColorGBP);
       cur += st;
     }
   if(CHF)
     {
       sl("~", cur, ColorCHF);
       cur += st;
     }
   if(AUD)
     {
       sl("~", cur, ColorAUD);
       cur+=st;
     }
   if(CAD)
     {
       sl("~", cur, ColorCAD);
       cur+=st;
     }
   if(JPY)
     {
       sl("~", cur, ColorJPY);
       cur += st;
     }
   if(NZD)
     {
       sl("~", cur, ColorNZD);
       cur+=st;
     }
//----
   int width = 0;
   if(0 > StringFind(Symbol(), "USD", 0))
       width = LineWidth;
   else 
       width = Line_Thickness;
   SetIndexStyle(0, DRAW_LINE, DRAW_LINE, width, ColorUSD);
   SetIndexBuffer(0, arrUSD);
   SetIndexLabel(0, "USD"); 
   if(0 > StringFind(Symbol(), "EUR", 0))
       width = LineWidth;
   else 
       width = Line_Thickness;
   SetIndexStyle(1, DRAW_LINE, DRAW_LINE, width, ColorEUR);
   SetIndexBuffer(1, arrEUR);
   SetIndexLabel(1, "EUR"); 
   if(0 > StringFind(Symbol(), "GBP", 0))
       width = LineWidth;
   else 
       width = Line_Thickness;
   SetIndexStyle(2, DRAW_LINE, DRAW_LINE, width, ColorGBP);
   SetIndexBuffer(2, arrGBP);
   SetIndexLabel(2, "GBP"); 
   if(0 > StringFind(Symbol(), "CHF", 0))
       width = LineWidth;
   else 
       width = Line_Thickness;
   SetIndexStyle(3, DRAW_LINE, DRAW_LINE, width, ColorCHF);
   SetIndexBuffer(3, arrCHF);
   SetIndexLabel(3, "CHF"); 
   if(0 > StringFind(Symbol(), "JPY", 0))
       width = LineWidth;
   else 
       width = Line_Thickness;
   SetIndexStyle(4, DRAW_LINE, DRAW_LINE, width, ColorJPY);
   SetIndexBuffer(4, arrJPY);
   SetIndexLabel(4, "JPY"); 
   if(0 > StringFind(Symbol(), "AUD", 0))
       width = LineWidth;
   else 
       width = Line_Thickness;
   SetIndexStyle(5, DRAW_LINE, DRAW_LINE, width, ColorAUD);
   SetIndexBuffer(5, arrAUD);
   SetIndexLabel(5, "AUD"); 
   if(0 > StringFind(Symbol(), "CAD", 0))
       width = LineWidth;
   else 
       width = Line_Thickness;
   SetIndexStyle(6, DRAW_LINE, DRAW_LINE, width, ColorCAD);
   SetIndexBuffer(6, arrCAD);
   SetIndexLabel(6, "CAD"); 
   if(0 > StringFind(Symbol(), "NZD", 0))
       width = LineWidth;
   else 
       width = Line_Thickness;
   SetIndexStyle(7, DRAW_LINE, DRAW_LINE, width, ColorNZD);
   SetIndexBuffer(7, arrNZD);
   SetIndexLabel(7, "NZD"); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i = 0; i < Objs; i++)
     {
       if(!ObjectDelete(Indicator_Name + i))
           Print("error: code #", GetLastError());
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
double MathTanh(double x)
  {
   double exp;
   if(x>0) {exp=MathExp(-2*x);return((1-exp)/(1+exp));}
   else {exp=MathExp(2*x);return((exp-1)/(1+exp));}
  }
  
double NormF(double x){
  double y;
  y = x;
  if (NormalizeValue){
     y = 50 + 50.0 / M_PI_2 * MathArctan(x / 0.003);
  }
  return(y);
}
int start()
  {
   int limit;
   int counted_bars = IndicatorCounted();
//---- check for errors
   if(counted_bars < 0) 
       return(-1);
//---- redraw last bar
   if(counted_bars > 0) 
      //counted_bars -= 10; //ORIGINAL
      counted_bars--;
   limit = Bars - counted_bars;
   RefreshRates();
   
   if (SaveFile){
     int FileHandle = FileOpen ("CCData.csv", FILE_CSV|FILE_WRITE|FILE_READ|FILE_SHARE_READ, ';');
     if(FileHandle > 0)
       FileSeek(FileHandle, 0, SEEK_END);
   }
   for(int i = 0; i < limit; i++)
     {
       // initial calculations
       if(EUR)
         {
           double EURUSD_Fast = ma( StringConcatenate("EURUSD",endfx), Fast, MA_Method, Applied_Price, i);
           double EURUSD_Slow = ma(StringConcatenate("EURUSD",endfx), Slow, MA_Method, Applied_Price, i);
           if (!EURUSD_Fast || !EURUSD_Slow)   
               break;   
           if (CalcMorePairs){
              double EURAUD_Fast = ma( StringConcatenate("EURAUD",endfx), Fast, MA_Method, Applied_Price, i);
              double EURAUD_Slow = ma(StringConcatenate("EURAUD",endfx), Slow, MA_Method, Applied_Price, i);
              double EURGBP_Fast = ma( StringConcatenate("EURGBP",endfx), Fast, MA_Method, Applied_Price, i);
              double EURGBP_Slow = ma(StringConcatenate("EURGBP",endfx), Slow, MA_Method, Applied_Price, i);
              double EURCAD_Fast = ma( StringConcatenate("EURCAD",endfx), Fast, MA_Method, Applied_Price, i);
              double EURCAD_Slow = ma(StringConcatenate("EURCAD",endfx), Slow, MA_Method, Applied_Price, i);
              
              double EURJPY_Fast = ma( StringConcatenate("EURJPY",endfx), Fast, MA_Method, Applied_Price, i);
              double EURJPY_Slow = ma(StringConcatenate("EURJPY",endfx), Slow, MA_Method, Applied_Price, i);
              if (JPY100){
                EURJPY_Fast /= 100.0;
                EURJPY_Slow /= 100.0;
              }
           }
         }
       if(GBP)
         {
           double GBPUSD_Fast = ma(StringConcatenate("GBPUSD",endfx), Fast, MA_Method, Applied_Price, i);
           double GBPUSD_Slow = ma(StringConcatenate("GBPUSD",endfx), Slow, MA_Method, Applied_Price, i);
           if(!GBPUSD_Fast || !GBPUSD_Slow)
               break;
           if (CalcMorePairs){               
              double GBPAUD_Fast = ma( StringConcatenate("GBPAUD",endfx), Fast, MA_Method, Applied_Price, i);
              double GBPAUD_Slow = ma(StringConcatenate("GBPAUD",endfx), Slow, MA_Method, Applied_Price, i);
              
              double GBPCAD_Fast = ma( StringConcatenate("GBPCAD",endfx), Fast, MA_Method, Applied_Price, i);
              double GBPCAD_Slow = ma(StringConcatenate("GBPCAD",endfx), Slow, MA_Method, Applied_Price, i);
              
              double GBPJPY_Fast = ma( StringConcatenate("GBPJPY",endfx), Fast, MA_Method, Applied_Price, i);
              double GBPJPY_Slow = ma(StringConcatenate("GBPJPY",endfx), Slow, MA_Method, Applied_Price, i);
              if (JPY100){
                GBPJPY_Fast /= 100.0;
                GBPJPY_Slow /= 100.0;
              }
              
           }
         }
       if(AUD)
         {
           double AUDUSD_Fast = ma(StringConcatenate("AUDUSD",endfx), Fast, MA_Method, Applied_Price, i);
           double AUDUSD_Slow = ma(StringConcatenate("AUDUSD",endfx), Slow, MA_Method, Applied_Price, i);
           if(!AUDUSD_Fast || !AUDUSD_Slow)
               break;
         }
       if(NZD)
         {
           double NZDUSD_Fast = ma(StringConcatenate("NZDUSD",endfx), Fast, MA_Method, Applied_Price, i);
           double NZDUSD_Slow = ma(StringConcatenate("NZDUSD",endfx), Slow, MA_Method, Applied_Price, i);
           if(!NZDUSD_Fast || !NZDUSD_Slow)
               break;
           if (CalcMorePairs){               
              double EURNZD_Fast = ma( StringConcatenate("EURNZD",endfx), Fast, MA_Method, Applied_Price, i);
              double EURNZD_Slow = ma(StringConcatenate("EURNZD",endfx), Slow, MA_Method, Applied_Price, i);
              
              double GBPNZD_Fast = ma( StringConcatenate("GBPNZD",endfx), Fast, MA_Method, Applied_Price, i);
              double GBPNZD_Slow = ma(StringConcatenate("GBPNZD",endfx), Slow, MA_Method, Applied_Price, i);
              
              double NZDCHF_Fast = ma( StringConcatenate("NZDCHF",endfx), Fast, MA_Method, Applied_Price, i);
              double NZDCHF_Slow = ma(StringConcatenate("NZDCHF",endfx), Slow, MA_Method, Applied_Price, i);
              
              double NZDCAD_Fast = ma( StringConcatenate("NZDCAD",endfx), Fast, MA_Method, Applied_Price, i);
              double NZDCAD_Slow = ma(StringConcatenate("NZDCAD",endfx), Slow, MA_Method, Applied_Price, i);
              
              double NZDJPY_Fast = ma( StringConcatenate("NZDJPY",endfx), Fast, MA_Method, Applied_Price, i);              
              double NZDJPY_Slow = ma(StringConcatenate("NZDJPY",endfx), Slow, MA_Method, Applied_Price, i);
              if (JPY100){
                NZDJPY_Fast /= 100.0;
                NZDJPY_Slow /= 100.0;
              }
                         
           }
         }
       if(CAD)
         {
           double USDCAD_Fast = ma(StringConcatenate("USDCAD",endfx), Fast, MA_Method, Applied_Price, i);
           double USDCAD_Slow = ma(StringConcatenate("USDCAD",endfx), Slow, MA_Method, Applied_Price, i);
           if(!USDCAD_Fast || !USDCAD_Slow)
               break;
           if (CalcMorePairs){
               double AUDCAD_Fast = ma( StringConcatenate("AUDCAD",endfx), Fast, MA_Method, Applied_Price, i);
               double AUDCAD_Slow = ma(StringConcatenate("AUDCAD",endfx), Slow, MA_Method, Applied_Price, i);               

              double CADJPY_Fast = ma( StringConcatenate("CADJPY",endfx), Fast, MA_Method, Applied_Price, i);
              double CADJPY_Slow = ma(StringConcatenate("CADJPY",endfx), Slow, MA_Method, Applied_Price, i);   
              if (JPY100){
                CADJPY_Fast /= 100.0;
                CADJPY_Slow /= 100.0;
              }            
           }
         }
       if(CHF)
         {
           double USDCHF_Fast = ma(StringConcatenate("USDCHF",endfx),Fast,MA_Method,Applied_Price,i);
           double USDCHF_Slow = ma(StringConcatenate("USDCHF",endfx),Slow,MA_Method,Applied_Price,i);
           if(!USDCHF_Fast || !USDCHF_Slow)
               break;
           if (CalcMorePairs){               
              double EURCHF_Fast = ma( StringConcatenate("EURCHF",endfx), Fast, MA_Method, Applied_Price, i);
              double EURCHF_Slow = ma(StringConcatenate("EURCHF",endfx), Slow, MA_Method, Applied_Price, i);
              
              double GBPCHF_Fast = ma( StringConcatenate("GBPCHF",endfx), Fast, MA_Method, Applied_Price, i);
              double GBPCHF_Slow = ma(StringConcatenate("GBPCHF",endfx), Slow, MA_Method, Applied_Price, i);              
              
              double CHFJPY_Fast = ma( StringConcatenate("CHFJPY",endfx), Fast, MA_Method, Applied_Price, i);
              double CHFJPY_Slow = ma(StringConcatenate("CHFJPY",endfx), Slow, MA_Method, Applied_Price, i); 
              if (JPY100){
                CHFJPY_Fast /= 100.0;
                CHFJPY_Slow /= 100.0;
              }             
           }                             
         }
       if(JPY)
         {
           double USDJPY_Fast = ma(StringConcatenate("USDJPY",endfx), Fast, MA_Method, Applied_Price, i) / 100.0;
           double USDJPY_Slow = ma(StringConcatenate("USDJPY",endfx), Slow, MA_Method, Applied_Price, i) / 100.0;
           if(!USDJPY_Fast || !USDJPY_Slow)
               break;
           if (CalcMorePairs){
               double AUDJPY_Fast = ma( StringConcatenate("AUDJPY",endfx), Fast, MA_Method, Applied_Price, i);
               double AUDJPY_Slow = ma(StringConcatenate("AUDJPY",endfx), Slow, MA_Method, Applied_Price, i); 
               if (JPY100){
                 AUDJPY_Fast /= 100.0;
                 AUDJPY_Slow /= 100.0;
              }
           }
         }
       // calculate strength
        if (((ShowOnlyPairOnChart==true) && (StringFind(Symbol(),"USD",0)!=-1))||((ShowOnlyPairOnChart==false) && (USD==true)))        
         {
           arrUSD[i] = 0;
           if(EUR) 
               arrUSD[i] += EURUSD_Slow - EURUSD_Fast;
           if(GBP) 
               arrUSD[i] += GBPUSD_Slow - GBPUSD_Fast;
           if(AUD) 
               arrUSD[i] += AUDUSD_Slow - AUDUSD_Fast;
           if(NZD) 
               arrUSD[i] += NZDUSD_Slow - NZDUSD_Fast;
           if(CHF) 
               arrUSD[i] += USDCHF_Fast - USDCHF_Slow;
           if(CAD) 
               arrUSD[i] += USDCAD_Fast - USDCAD_Slow;
           if(JPY) 
               arrUSD[i] += USDJPY_Fast - USDJPY_Slow;
               
           arrUSD[i] = NormF(arrUSD[i]);
         }// end if USD
        if (((ShowOnlyPairOnChart==true) && (StringFind(Symbol(),"EUR",0)!=-1))||((ShowOnlyPairOnChart==false) && (EUR==true)))        
      
         {
           arrEUR[i] = 0;
           if (CalcMorePairs){          
              if(USD) 
                  arrEUR[i] += EURUSD_Fast - EURUSD_Slow;
              if(GBP) 
                  arrEUR[i] += EURGBP_Fast - EURGBP_Slow; //EURUSD_Fast / GBPUSD_Fast - EURUSD_Slow / GBPUSD_Slow;
              if(AUD) 
                  arrEUR[i] += EURAUD_Fast - EURAUD_Slow; //EURUSD_Fast / AUDUSD_Fast - EURUSD_Slow / AUDUSD_Slow;
              if(NZD) 
                  arrEUR[i] += EURUSD_Fast / NZDUSD_Fast - EURUSD_Slow / NZDUSD_Slow;
              if(CHF) 
                  arrEUR[i] += EURUSD_Fast*USDCHF_Fast - EURUSD_Slow*USDCHF_Slow;
              if(CAD) 
                  arrEUR[i] += EURCAD_Fast - EURCAD_Slow;//EURUSD_Fast*USDCAD_Fast - EURUSD_Slow*USDCAD_Slow;
              if(JPY) 
                  arrEUR[i] += EURJPY_Fast - EURJPY_Slow;//EURUSD_Fast*USDJPY_Fast - EURUSD_Slow*USDJPY_Slow;
           }
           else //original
           {

              if(USD) 
                  arrEUR[i] += EURUSD_Fast - EURUSD_Slow;
              if(GBP) 
                  arrEUR[i] += EURUSD_Fast / GBPUSD_Fast - EURUSD_Slow / GBPUSD_Slow;
              if(AUD) 
                  arrEUR[i] += EURUSD_Fast / AUDUSD_Fast - EURUSD_Slow / AUDUSD_Slow;
              if(NZD) 
                  arrEUR[i] += EURUSD_Fast / NZDUSD_Fast - EURUSD_Slow / NZDUSD_Slow;
              if(CHF) 
                  arrEUR[i] += EURUSD_Fast*USDCHF_Fast - EURUSD_Slow*USDCHF_Slow;
              if(CAD) 
                  arrEUR[i] += EURUSD_Fast*USDCAD_Fast - EURUSD_Slow*USDCAD_Slow;
              if(JPY) 
                  arrEUR[i] += EURUSD_Fast*USDJPY_Fast - EURUSD_Slow*USDJPY_Slow;
           }                     
           arrEUR[i] = NormF(arrEUR[i]);
         }// end if EUR
      if (((ShowOnlyPairOnChart==true) && (StringFind(Symbol(),"GBP",0)!=-1))||((ShowOnlyPairOnChart==false) && (GBP==true)))        
         {
           arrGBP[i] = 0;
           if (CalcMorePairs){          
              if(USD) 
                  arrGBP[i] += GBPUSD_Fast - GBPUSD_Slow;
              if(EUR) 
                  arrGBP[i] += EURGBP_Slow - EURGBP_Fast;//EURUSD_Slow / GBPUSD_Slow - EURUSD_Fast / GBPUSD_Fast;
              if(AUD) 
                  arrGBP[i] += GBPAUD_Fast - GBPAUD_Slow;//GBPUSD_Fast / AUDUSD_Fast - GBPUSD_Slow / AUDUSD_Slow;
              if(NZD) 
                  arrGBP[i] += GBPUSD_Fast / NZDUSD_Fast - GBPUSD_Slow / NZDUSD_Slow;
              if(CHF) 
                  arrGBP[i] += GBPUSD_Fast*USDCHF_Fast - GBPUSD_Slow*USDCHF_Slow;
              if(CAD) 
                  arrGBP[i] += GBPCAD_Fast - GBPCAD_Slow;//GBPUSD_Fast*USDCAD_Fast - GBPUSD_Slow*USDCAD_Slow;
              if(JPY) 
                  arrGBP[i] += GBPJPY_Fast - GBPJPY_Slow;//GBPUSD_Fast*USDJPY_Fast - GBPUSD_Slow*USDJPY_Slow;
           }
           else //original
           {
              if(USD) 
                  arrGBP[i] += GBPUSD_Fast - GBPUSD_Slow;
              if(EUR) 
                  arrGBP[i] += EURUSD_Slow / GBPUSD_Slow - EURUSD_Fast / GBPUSD_Fast;
              if(AUD) 
                  arrGBP[i] += GBPUSD_Fast / AUDUSD_Fast - GBPUSD_Slow / AUDUSD_Slow;
              if(NZD) 
                  arrGBP[i] += GBPUSD_Fast / NZDUSD_Fast - GBPUSD_Slow / NZDUSD_Slow;
              if(CHF) 
                  arrGBP[i] += GBPUSD_Fast*USDCHF_Fast - GBPUSD_Slow*USDCHF_Slow;
              if(CAD) 
                  arrGBP[i] += GBPUSD_Fast*USDCAD_Fast - GBPUSD_Slow*USDCAD_Slow;
              if(JPY) 
                  arrGBP[i] += GBPUSD_Fast*USDJPY_Fast - GBPUSD_Slow*USDJPY_Slow;
           }
           arrGBP[i] = NormF(arrGBP[i]);
         }// end if GBP
     if (((ShowOnlyPairOnChart==true) && (StringFind(Symbol(),"AUD",0)!=-1))||((ShowOnlyPairOnChart==false) && (AUD==true)))        
         {
            arrAUD[i] = 0;
            if (CalcMorePairs){           
               if(USD) 
                  arrAUD[i] += AUDUSD_Fast - AUDUSD_Slow;
               if(EUR) 
                  arrAUD[i] += EURAUD_Slow - EURAUD_Fast;//EURUSD_Slow / AUDUSD_Slow - EURUSD_Fast / AUDUSD_Fast;
               if(GBP) 
                  arrAUD[i] += GBPAUD_Slow - GBPAUD_Fast;// GBPUSD_Slow / AUDUSD_Slow - GBPUSD_Fast / AUDUSD_Fast;
               //AUDNZD
               if(NZD) arrAUD[i] += AUDUSD_Fast / NZDUSD_Fast - AUDUSD_Slow / NZDUSD_Slow;
               //AUDCHF
               if(CHF) arrAUD[i] += AUDUSD_Fast*USDCHF_Fast - AUDUSD_Slow*USDCHF_Slow;
               if(CAD) 
                  arrAUD[i] += AUDCAD_Fast - AUDCAD_Slow;//AUDUSD_Fast*USDCAD_Fast - AUDUSD_Slow*USDCAD_Slow;
               if(JPY) 
                  arrAUD[i] += AUDJPY_Fast - AUDJPY_Slow;////AUDUSD_Fast*USDJPY_Fast - AUDUSD_Slow*USDJPY_Slow;		   
            }
            else //original
            {
              if(USD) 
                  arrAUD[i] += AUDUSD_Fast - AUDUSD_Slow;
              if(EUR) 
                  arrAUD[i] += EURUSD_Slow / AUDUSD_Slow - EURUSD_Fast / 
                               AUDUSD_Fast;
              if(GBP) 
                  arrAUD[i] += GBPUSD_Slow / AUDUSD_Slow - GBPUSD_Fast / 
                               AUDUSD_Fast;
              if(NZD) 
                  arrAUD[i] += AUDUSD_Fast / NZDUSD_Fast - AUDUSD_Slow / 
                               NZDUSD_Slow;
              if(CHF) 
                  arrAUD[i] += AUDUSD_Fast*USDCHF_Fast - 
                               AUDUSD_Slow*USDCHF_Slow;
              if(CAD) 
                  arrAUD[i] += AUDUSD_Fast*USDCAD_Fast - 
                               AUDUSD_Slow*USDCAD_Slow;
              if(JPY) 
                  arrAUD[i] += AUDUSD_Fast*USDJPY_Fast - 
                               AUDUSD_Slow*USDJPY_Slow;
			  }		
           arrAUD[i] = NormF(arrAUD[i]);                 
         }// end if AUD
     if (((ShowOnlyPairOnChart==true) && (StringFind(Symbol(),"NZD",0)!=-1))||((ShowOnlyPairOnChart==false) && (NZD==true)))        
       
         {
           arrNZD[i] = 0;
           if (CalcMorePairs){
              if(USD) 
                  arrNZD[i] += NZDUSD_Fast - NZDUSD_Slow;
              if(EUR) 
                  arrNZD[i] += EURNZD_Slow - EURNZD_Fast;//EURUSD_Slow / NZDUSD_Slow - EURUSD_Fast / NZDUSD_Fast;
              if(GBP) 
                  arrNZD[i] += GBPNZD_Fast - GBPNZD_Slow;//GBPUSD_Slow / NZDUSD_Slow - GBPUSD_Fast / NZDUSD_Fast;
              if(AUD) 
                  arrNZD[i] += AUDUSD_Slow / NZDUSD_Slow - AUDUSD_Fast / NZDUSD_Fast;
              if(CHF) 
                  arrNZD[i] += NZDCHF_Fast - NZDCHF_Slow;//NZDUSD_Fast*USDCHF_Fast - NZDUSD_Slow*USDCHF_Slow;
              if(CAD) 
                  arrNZD[i] += NZDCAD_Fast - NZDCAD_Slow;//NZDUSD_Fast*USDCAD_Fast - NZDUSD_Slow*USDCAD_Slow;
              if(JPY) 
                  arrNZD[i] += NZDJPY_Fast - NZDJPY_Slow;//NZDUSD_Fast*USDJPY_Fast - NZDUSD_Slow*USDJPY_Slow;           
           }
           else //original
           {
              if(USD) 
                  arrNZD[i] += NZDUSD_Fast - NZDUSD_Slow;
              if(EUR) 
                  arrNZD[i] += EURUSD_Slow / NZDUSD_Slow - EURUSD_Fast / NZDUSD_Fast;
              if(GBP) 
                  arrNZD[i] += GBPUSD_Slow / NZDUSD_Slow - GBPUSD_Fast / NZDUSD_Fast;
              if(AUD) 
                  arrNZD[i] += AUDUSD_Slow / NZDUSD_Slow - AUDUSD_Fast / NZDUSD_Fast;
              if(CHF) 
                  arrNZD[i] += NZDUSD_Fast*USDCHF_Fast - NZDUSD_Slow*USDCHF_Slow;
              if(CAD) 
                  arrNZD[i] += NZDUSD_Fast*USDCAD_Fast - NZDUSD_Slow*USDCAD_Slow;
              if(JPY) 
                  arrNZD[i] += NZDUSD_Fast*USDJPY_Fast - NZDUSD_Slow*USDJPY_Slow;
           }
           arrNZD[i] = NormF(arrNZD[i]);                 
         }// end if NZD
     if (((ShowOnlyPairOnChart==true) && (StringFind(Symbol(),"CAD",0)!=-1))||((ShowOnlyPairOnChart==false) && (CAD==true)))        
         {
           arrCAD[i] = 0;
           if (CalcMorePairs){
              if(USD) 
                arrCAD[i] += USDCAD_Slow - USDCAD_Fast;
              if(EUR) 
                arrCAD[i] += EURCAD_Slow - EURCAD_Fast;//EURUSD_Slow*USDCAD_Slow - EURUSD_Fast*USDCAD_Fast;
              if(GBP) 
                arrCAD[i] += GBPCAD_Slow - GBPCAD_Fast;//GBPUSD_Slow*USDCAD_Slow - GBPUSD_Fast*USDCAD_Fast;
              if(AUD) 
                arrCAD[i] += AUDCAD_Slow - AUDCAD_Fast;//AUDUSD_Slow*USDCAD_Slow - AUDUSD_Fast*USDCAD_Fast;
              if(NZD) 
                arrCAD[i] += NZDUSD_Slow*USDCAD_Slow - NZDUSD_Fast*USDCAD_Fast;
              if(CHF) 
                arrCAD[i] += USDCHF_Fast / USDCAD_Fast - USDCHF_Slow / USDCAD_Slow;
              if(JPY) 
                arrCAD[i] += CADJPY_Fast - CADJPY_Slow;//USDJPY_Fast / USDCAD_Fast - USDJPY_Slow / USDCAD_Slow;
           }
           else //original
           {
              if(USD) 
                arrCAD[i] += USDCAD_Slow - USDCAD_Fast;
              if(EUR) 
                arrCAD[i] += EURUSD_Slow*USDCAD_Slow - EURUSD_Fast*USDCAD_Fast;
              if(GBP) 
                arrCAD[i] += GBPUSD_Slow*USDCAD_Slow - GBPUSD_Fast*USDCAD_Fast;
              if(AUD) 
                arrCAD[i] += AUDUSD_Slow*USDCAD_Slow - AUDUSD_Fast*USDCAD_Fast;
              if(NZD) 
                arrCAD[i] += NZDUSD_Slow*USDCAD_Slow - NZDUSD_Fast*USDCAD_Fast;
              if(CHF) 
                arrCAD[i] += USDCHF_Fast / USDCAD_Fast - USDCHF_Slow / USDCAD_Slow;
              if(JPY) 
                arrCAD[i] += USDJPY_Fast / USDCAD_Fast - USDJPY_Slow / USDCAD_Slow;
           }
           arrCAD[i] = NormF(arrCAD[i]);             
         }// end if CAD
        
       if (((ShowOnlyPairOnChart==true) && (StringFind(Symbol(),"CHF",0)!=-1))||((ShowOnlyPairOnChart==false) && (CHF==true)))        
         {
           arrCHF[i] = 0;
           if (CalcMorePairs){
              if(USD) 
                  arrCHF[i] += USDCHF_Slow - USDCHF_Fast;
              if(EUR) 
                  arrCHF[i] += EURCHF_Slow - EURCHF_Fast;//EURUSD_Slow*USDCHF_Slow - EURUSD_Fast*USDCHF_Fast;
              if(GBP) 
                  arrCHF[i] += GBPCHF_Slow - GBPCHF_Fast;//GBPUSD_Slow*USDCHF_Slow - GBPUSD_Fast*USDCHF_Fast;
              if(AUD) 
                  arrCHF[i] += AUDUSD_Slow*USDCHF_Slow - AUDUSD_Fast*USDCHF_Fast;
              if(NZD) 
                  arrCHF[i] += NZDCHF_Slow - NZDCHF_Fast;//NZDUSD_Slow*USDCHF_Slow - NZDUSD_Fast*USDCHF_Fast;
              if(CAD) 
                  arrCHF[i] += USDCHF_Slow / USDCAD_Slow - USDCHF_Fast / USDCAD_Fast;
              if(JPY) 
                  arrCHF[i] += CHFJPY_Fast - CHFJPY_Slow;//USDJPY_Fast / USDCHF_Fast - USDJPY_Slow / USDCHF_Slow;
           }
           else //original
           {
              if(USD) 
                  arrCHF[i] += USDCHF_Slow - USDCHF_Fast;
              if(EUR) 
                  arrCHF[i] += EURUSD_Slow*USDCHF_Slow - EURUSD_Fast*USDCHF_Fast;
              if(GBP) 
                  arrCHF[i] += GBPUSD_Slow*USDCHF_Slow - GBPUSD_Fast*USDCHF_Fast;
              if(AUD) 
                  arrCHF[i] += AUDUSD_Slow*USDCHF_Slow - AUDUSD_Fast*USDCHF_Fast;
              if(NZD) 
                  arrCHF[i] += NZDUSD_Slow*USDCHF_Slow - NZDUSD_Fast*USDCHF_Fast;
              if(CAD) 
                  arrCHF[i] += USDCHF_Slow / USDCAD_Slow - USDCHF_Fast / USDCAD_Fast;
              if(JPY) 
                  arrCHF[i] += USDJPY_Fast / USDCHF_Fast - USDJPY_Slow / USDCHF_Slow;
           }
              
           arrCHF[i] = NormF(arrCHF[i]);                 
         }// end if CHF
        if (((ShowOnlyPairOnChart==true) && (StringFind(Symbol(),"JPY",0)!=-1))||((ShowOnlyPairOnChart==false) && (JPY==true)))        
         { 
           arrJPY[i] = 0;
           if (CalcMorePairs){
              if(USD) 
                arrJPY[i] += USDJPY_Slow - USDJPY_Fast;
              if(EUR) 
                arrJPY[i] += EURJPY_Slow - EURJPY_Fast;// EURUSD_Slow*USDJPY_Slow - EURUSD_Fast*USDJPY_Fast;
              if(GBP) 
                arrJPY[i] += GBPJPY_Slow - GBPJPY_Fast;//GBPUSD_Slow*USDJPY_Slow - GBPUSD_Fast*USDJPY_Fast;
              if(AUD) 
                arrJPY[i] += AUDJPY_Slow - AUDJPY_Fast;//AUDUSD_Slow*USDJPY_Slow - AUDUSD_Fast*USDJPY_Fast;
              if(NZD) 
                arrJPY[i] += NZDUSD_Slow*USDJPY_Slow - NZDUSD_Fast*USDJPY_Fast;
              if(CAD) 
                arrJPY[i] += CADJPY_Slow - CADJPY_Fast;//USDJPY_Slow / USDCAD_Slow - USDJPY_Fast / USDCAD_Fast;
              if(CHF) 
                arrJPY[i] += USDJPY_Slow / USDCHF_Slow - USDJPY_Fast / USDCHF_Fast;
           }
           else //original
           {
              if(USD) 
                arrJPY[i] += USDJPY_Slow - USDJPY_Fast;
              if(EUR) 
                arrJPY[i] += EURUSD_Slow*USDJPY_Slow - EURUSD_Fast*USDJPY_Fast;
              if(GBP) 
                arrJPY[i] += GBPUSD_Slow*USDJPY_Slow - GBPUSD_Fast*USDJPY_Fast;
              if(AUD) 
                arrJPY[i] += AUDUSD_Slow*USDJPY_Slow - AUDUSD_Fast*USDJPY_Fast;
              if(NZD) 
                arrJPY[i] += NZDUSD_Slow*USDJPY_Slow - NZDUSD_Fast*USDJPY_Fast;
              if(CAD) 
                arrJPY[i] += USDJPY_Slow / USDCAD_Slow - USDJPY_Fast / USDCAD_Fast;
              if(CHF) 
                arrJPY[i] += USDJPY_Slow / USDCHF_Slow - USDJPY_Fast / USDCHF_Fast;           
           }
          
           arrJPY[i] = NormF(arrJPY[i]);             
         }// end if JPY
       if (SaveFile &&  (i < Bars) && (FileHandle > 0)){
         FileWrite(FileHandle, TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS), TimeToStr(Time[i], TIME_DATE|TIME_SECONDS), arrUSD[i], arrEUR[i], arrGBP[i], arrAUD[i], arrNZD[i], arrCAD[i], arrCHF[i], arrJPY[i]);
       }  
     }//end block for(int i=0; i<limit; i++)
//----
   if (SaveFile && (FileHandle > 0))
     FileClose(FileHandle);

   RefreshRates();
   return(0);
  }
//+------------------------------------------------------------------+
//|  Subroutines                                                     |
//+------------------------------------------------------------------+
double ma(string sym, int per, int Mode, int Price2, int i)
  {
    return(iMA(sym, 0, per, 0, Mode, Price2, i));
  }   
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void sl(string sym, int y, color col)
  {
   int window = WindowFind(Indicator_Name);
   string ID = Indicator_Name + Objs;
   Print("ID:", ID);
   int tmp = 10 + y;
   Objs++;
   if(ObjectCreate(ID, OBJ_LABEL, window, 0, 0))
     {
       //ObjectSet(ID, OBJPROP_CORNER, 1);
       ObjectSet(ID, OBJPROP_XDISTANCE, y + 35);
       ObjectSet(ID, OBJPROP_YDISTANCE, 0);
       ObjectSetText(ID, sym, 18, "Arial Black", col);
     }
  } 
//+------------------------------------------------------------------+

void fctDebugWatchesWorkaround()
{
   MqlRates rate;
   Print(rate.open); // Force expressions evaluation while debugging
}